package simplexmlbreaker;

/**
 *
 * @author m@rtlin <martlin@seznam.cz>
 */
public enum Actions {
    HELP("--help", "-h"),
    QUIET("--quiet", "-q"),
    BREAK_FILE("--break-file", "-f"),
    BREAK_LINE("--break-line", "-l"),
    REMOVE_LINE("--remove-line", "-r"),
    DUPLY_LINE("--duplicate-line", "-d"),
    INS_ELEM("--insert-elem", "-e"),
    INS_ATTR("--insert-atribute", "-a"),
    INS_CHARS("--insert-chars", "-c");
    
    
    private String longVersion;
    private String shortVersion;

    public String getLongVersion() {
	return longVersion;
    }

    public String getShortVersion() {
	return shortVersion;
    }
    
    private Actions(String longVersion, String shortVersion) {
	this.longVersion = longVersion;
	this.shortVersion = shortVersion;
    }
    
    
    public static Actions getCmdSwitch(String cmdSwStr) {
	for (Actions sw: values()) {
	    if (cmdSwStr.equals(sw.shortVersion) || cmdSwStr.equals(sw.longVersion))
		return sw;
	}
	return null;
    }
    
}
