/*
 * Simple XML Breaker je aplikace, která má za úkol jedinné - ničit! 
 * Konkrétně útočit na XML soubory a nelítostně jim všleijak škdoti a sabotovat jim.
 * 
 * Vznikl jako utilka majíce pomoct s testováním Ročníkového projektu, 
 * který měl být pochopitelně odolný vůči všem možným poškozením XML souboru,
 * se kterým pracoval.
 * 
 * vizte -h / --help
 * 
 */
package simplexmlbreaker;

import java.io.*;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 *
 * @author m@rtlin <martlin@seznam.cz>
 */
public class SimpleXMLBreaker {

    public static String VERISON = "1.2";
    private static Queue<Actions> actions2do = new LinkedList<>();
    private static boolean verbose = true;  //v základu bude aplikace upovídaná
    private static int lineIndex = 0;
    private static int linesCount;
    protected static final String DFLT_STRINGS[] = {"foo", "bar", "baz", "aux", "xml", "simple", "breaker", "java", "cake", "lorem", "ipsum", "matrix", "nil"};

    public static void help() {
	System.out.println(""
		+ "Simple XML Breaker " + VERISON + "\n"
		+ "13. dub 2013, made by m@rtlin\n"
		+ "\n\n"
		+ "Použití:\n"
		+ "	sxmlb [<přepínače> ...] <název XML souboru>\n"
		+ "\n\n"
		+ "Přepínače:\n"
		+ "	" + Actions.HELP.getLongVersion() + "\t | " + Actions.HELP.getShortVersion()
		+ "\t tato nápověda a konec\n"
		+ "	" + Actions.QUIET.getLongVersion() + "\t | " + Actions.QUIET.getShortVersion()
		+ "\t tichý režim (nebude vypisovat informační hlášky)\n"
		+ "	" + Actions.BREAK_FILE.getLongVersion() + "\t | " + Actions.BREAK_FILE.getShortVersion()
		+ "\t usekne několik posledních řádků souboru\n"
		+ "	" + Actions.BREAK_LINE.getLongVersion() + "\t | " + Actions.BREAK_LINE.getShortVersion()
		+ "\t usekne konec některého řádku\n"
		+ "	" + Actions.REMOVE_LINE.getLongVersion() + "\t | " + Actions.REMOVE_LINE.getShortVersion()
		+ "\t odebere některý řádek\n"
		+ "	" + Actions.DUPLY_LINE.getLongVersion() + "\t | " + Actions.DUPLY_LINE.getShortVersion()
		+ "\t vloží některý řádek ještě jednou někam dřív\n"
		+ "	" + Actions.INS_ELEM.getLongVersion() + "\t | " + Actions.INS_ELEM.getShortVersion()
		+ "\t vloží smyšlený element\n"
		+ "	" + Actions.INS_ATTR.getLongVersion() + "\t | " + Actions.INS_ATTR.getShortVersion()
		+ "\t vloží smyšlený atribut některému elementu\n"
		+ "	" + Actions.INS_CHARS.getLongVersion() + "\t | " + Actions.INS_CHARS.getShortVersion()
		+ "\t vloží pár znaků/slovo někam úplně libovolně do textu\n"
		+ "\n\n"
		+ " První nepřepínač je považován za název souboru\n"
		+ " Přepínače se MŮŽOU opakovat a můžou tak způsobit VÍCE PROVEDENÍ jednotlivých poškození (ale je to o náhodě, nemusí se tak stát)\n"
		+ " Bez přepínačů se provede jedno náhodné poškození a " + (!verbose ? "ne" : "") + "bude upovídaný.\n\n"
		+ " Hodně štěstí a zábavy ... \n"
		+ "");
    }

    private static void log(String message) {
	if (verbose) {
	    System.out.println("Řádek " + lineIndex + ": " + message);
	}
    }

    private static List<String> readFile(File file) throws FileNotFoundException, IOException {
	List<String> result = new LinkedList<>();
	FileReader fReader = new FileReader(file);

	try (BufferedReader reader = new BufferedReader(fReader)) {
	    while (reader.ready()) {
		result.add(reader.readLine());
	    }
	}

	return result;
    }

    private static void writeFile(List<String> fileContent, File file) throws IOException {
	FileWriter fWriter = new FileWriter(file);

	try (BufferedWriter writer = new BufferedWriter(fWriter)) {
	    for (String line : fileContent) {
		writer.write(line + '\n');
	    }
	}
    }

    public static List<String> readFile(String filename) {
	File file = new File(filename);
	List<String> fileContent = null;
	try {
	    fileContent = readFile(file);
	    linesCount = fileContent.size();
	    log("Načteno " + linesCount + " řádků.");
	} catch (FileNotFoundException ex) {
	    System.err.println("Soubor " + filename + " nenalezen.");
	    System.exit(1);
	} catch (IOException ex) {
	    System.err.println("Vstupně-výstupní chyba. Dejte si kafe a modlete se, že pomůže, když to zkusíte za chvíli.");
	    System.exit(2);
	}
	return fileContent;
    }

    public static void writeFile(List<String> fileContent, String filename) {
	File file = new File(filename);
	try {
	    writeFile(fileContent, file);
	    log("Soubor uložen. " + (actions2do.size() != 0 ? "Nezpracovalo se posledních " + actions2do.size() + " poškození." : ""));
	} catch (FileNotFoundException ex) {
	    System.err.println("Soubor " + filename + " nenalezen.");
	    System.exit(3);
	} catch (IOException ex) {
	    System.err.println("Vstupně-výstupní chyba. Dejte si kafe a modlete se, že pomůže, když to zkusíte za chvíli.");
	    System.exit(4);
	}
    }

    protected static String processArgs(String[] args) {
	int i = 0;
	while (i < args.length) {
	    Actions sw = Actions.getCmdSwitch(args[i]);
	    if (sw == null) {
		return args[i];
	    }

	    if (sw == Actions.HELP) {
		help();
		System.exit(0);
	    } else if (sw == Actions.QUIET) {
		verbose = false;
	    } else {
		actions2do.add(sw);
	    }
	    i++;
	}
	System.err.println("Nepředán žádný soubor. Viz "
		+ Actions.HELP.getLongVersion() + " / " + Actions.HELP.getShortVersion() + " pro nápovědu.");
	System.exit(5);
	return null;
    }

    protected static Actions randomAction() {
	int randActIndx = (int)(Math.random() * Actions.values().length - 2) + 2;
	return Actions.values()[randActIndx];
    }

    protected static List<String> doActions(List<String> fileContent) {
	while (!actions2do.isEmpty()) {
	    Actions action = actions2do.poll();
	    lineIndex += (int) (Math.random() * linesCount / ((actions2do.size() == 0) ? 1 : actions2do.size()));

	    if (lineIndex >= linesCount) { //pokud už jsme za souborem
		lineIndex = linesCount;
		break;
	    }

	    switch (action) {
		case BREAK_FILE:
		    fileContent = breakFile(fileContent);
		    return fileContent;	//tímhle už se končí
		case BREAK_LINE:
		    fileContent = breakLine(fileContent);
		    break;
		case REMOVE_LINE:
		    fileContent = removeLine(fileContent);
		    break;
		case DUPLY_LINE:
		    fileContent = duplicateLine(fileContent);
		    break;
		case INS_ELEM:
		    fileContent = insertElem(fileContent);
		    break;
		case INS_ATTR:
		    fileContent = insertAttr(fileContent);
		    break;
		case INS_CHARS:
		    fileContent = insertChars(fileContent);
		    break;
	    }

	}
	return fileContent;
    }

    private static List<String> breakFile(List<String> fileContent) {
	fileContent = fileContent.subList(0, lineIndex);
	log("Zbytek souboru odříznut.");
	return fileContent;
    }

    private static List<String> breakLine(List<String> fileContent) {
	String line = fileContent.get(lineIndex);
	int end = (int) (Math.random() * line.length());
	fileContent.set(lineIndex, line.substring(0, end));
	log("Řádek oříznut na " + end + " znaků.");
	return fileContent;
    }

    private static List<String> removeLine(List<String> fileContent) {
	fileContent.remove(lineIndex);
	linesCount--;
	log("Řádek odstraněn.");
	return fileContent;
    }

    private static List<String> duplicateLine(List<String> fileContent) {
	String lineCopy = fileContent.get(lineIndex);
	int newPos = (int) (Math.random() * lineIndex);
	fileContent.add(newPos, lineCopy);
	linesCount++;
	log("Řádek zkopírován na " + newPos + ".");
	return fileContent;
    }

    private static List<String> insertElem(List<String> fileContent) {
	StringBuilder strb = new StringBuilder();
	strb.append("<");
	strb.append(randomString());
	strb.append("/>");
	fileContent.add(lineIndex, strb.toString());
	linesCount++;

	log("Přidán element " + strb.toString() + ".");
	return fileContent;
    }

    private static List<String> insertAttr(List<String> fileContent) {
	String line = fileContent.get(lineIndex);
	StringBuilder strb = new StringBuilder();
	strb.append(" ");
	strb.append(randomString());
	strb.append("=\"");
	strb.append(randomString());
	strb.append("\" ");

	line = line.replaceFirst("\\s", strb.toString());
	fileContent.set(lineIndex, line);
	log("Přidán atribut " + strb.toString() + ".");
	return fileContent;
    }

    private static List<String> insertChars(List<String> fileContent) {
	String line = fileContent.get(lineIndex);
	String insertion = randomString();
	int insertPos = (int) (Math.random() * line.length());
	String before = line.substring(0, insertPos);
	String after = line.substring(insertPos, line.length());

	StringBuilder strb = new StringBuilder();
	strb.append(before);
	strb.append(insertion);
	strb.append(after);

	fileContent.set(lineIndex, strb.toString());
	log("Na pozici " + insertPos + " vloženy znaky " + insertion + ".");
	return fileContent;
    }

    protected static char randomChar() {
	switch ((int) (Math.random() * 3)) {
	    case 0:
		return (char) ('a' + Math.random() * ('z' - 'a'));
	    case 1:
		return (char) ('A' + Math.random() * ('Z' - 'A'));
	    case 2:
		return (char) ('0' + Math.random() * ('9' - '0'));
	    default:
		return '-';
	}
    }

    protected static String randomString() {
	int rand = (int) (Math.random() * DFLT_STRINGS.length * 4);
	if (rand < DFLT_STRINGS.length) {
	    return DFLT_STRINGS[rand];
	} else {
	    int length = (int) (Math.random() * 10) + 2;
	    int i;
	    StringBuilder strb = new StringBuilder();
	    for (i = 0; i < length; i++) {
		strb.append(randomChar());
	    }
	    return strb.toString();
	}
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	String filename = processArgs(args);
	if (actions2do.size() == 0) {
	    actions2do.add(randomAction());
	}

	List<String> file = readFile(filename);
	file = doActions(file);
	writeFile(file, filename);

    }
}
